unit ZitateServerDB;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, ZitateDB, ZitateMsg;

{ TZitadell }

const
   daten_slash = {$IFDEF Linux} '/' {$ELSE} '\' {$ENDIF};

type
   TZitadellDB = class(TObject)
      constructor create;
      function openSQLiteDatabase: boolean;
   private
      function testSQLiteTabelle: boolean;
      function anlegenSQLiteTabelle: boolean;
   private
      zdatabase: string;
      zstill, zonline: boolean;
   public
      property still: boolean read zstill write zstill;
      property online: boolean read zonline write zonline;
      property daten_database: string read zdatabase write zdatabase;
   end;

var
   ZitadellDB: TZitadellDB;

implementation

uses Dos, LConvEncoding;

{ Pfad... }

{ ZitateServer Constructor }

constructor TZitadellDB.Create;
begin
   daten_database:= 'dbTest.s3db';
   still:= true; online:= false;
   zitateDB1.anlegen_erlaubt:=false;
   //SQLite Connect erfolgt im zitateDB !
end;

function TZitadellDB.openSQLiteDatabase: boolean;
begin
    if not online then begin
          online:= zitateDB1.dbConnectOK( daten_database );

          if online then
             if not testSQLiteTabelle
	     then online:= ( anlegenSQLiteTabelle and testSQLiteTabelle );
    end;
    Result:= online;
end;

function TZitadellDB.testSQLiteTabelle: boolean;
begin
   Result:= zitateDB1.testTabellenOK;
end;

function TZitadellDB.anlegenSQLiteTabelle: boolean;
var dbOK:boolean;
begin
   dbOK:= zitateDB1.tabellenAnlegenOK;
   if dbOK then
      if not still then SystemMeldung( 'Die Tabellen in der Datenbank wurden neu angelegt' );
   Result:= dbOK;
end;

begin
   Randomize;
   ZitadellDB:=TZitadellDB.Create;
end.
